#! /bin/bash
#!/usr/bin/expect
# unpass - script for tms unpasswd

#set -x

HOST=$1
USER=$2
PASSWD=$3
if [ $# -eq 3 ]
 then
 ping -c 1 -w 1 ${HOST} > /dev/null 2>&1
 if [ $? != 0 ]
 then
 echo "unpass: Host ${HOST} is not ready"
 exit 1
 fi

 if [ ! -f ~/.ssh/id_dsa ]
 then
 ssh-keygen -m PEM -t "dsa" -N "" -f ~/.ssh/id_dsa > /dev/null 2>&1
 fi
 dsa=`ssh-keygen -y -t "dsa" -f ~/.ssh/id_dsa`

 if [ ! -f ~/.ssh/id_rsa ]
 then
 ssh-keygen -m PEM -t "rsa" -N "" -f ~/.ssh/id_rsa > /dev/null 2>&1
 fi
 rsa=`ssh-keygen -y -t "rsa" -f ~/.ssh/id_rsa`

 if [ ! -f ~/.ssh/identity ]
 then
 ssh-keygen -m PEM -t "rsa1" -N "" -f ~/.ssh/identity > /dev/null 2>&1
  if [ $? -eq 0 ]
  then
  rsa1=`ssh-keygen -y -t "rsa1" -f ~/.ssh/identity`
  fi
 fi

 ds=${dsa:8:100}

 sshpass -p "$PASSWD" ssh -o StrictHostKeyChecking=no ${USER}@${HOST} "mkdir -p ~/.ssh; \
 touch ~/.ssh/authorized_keys; \
 grep \"${ds}\" ~/.ssh/authorized_keys > /dev/null 2>&1; \
 res=\$?; \
 if [ \$res = 1 ]; then \
 echo \"${dsa}\" >> ~/.ssh/authorized_keys; \
 echo \"${rsa}\" >> ~/.ssh/authorized_keys; \
 echo \"${rsa1}\" >> ~/.ssh/authorized_keys; \
 fi;" > /dev/null 2>&1

 if [ $? -ne 0 ]
 then
 expect -c 'spawn ssh-copy-id -i /root/.ssh/id_dsa.pub -o StrictHostKeyChecking=no '${USER}'@'${HOST}'
 expect "*assword*" { send "'$PASSWD'\n" }
 expect eof' > /dev/null 2>&1

 expect -c 'spawn ssh-copy-id -i /root/.ssh/id_rsa.pub -o StrictHostKeyChecking=no '${USER}'@'${HOST}'
 expect "*assword*" { send "'$PASSWD'\n" }
 expect eof' > /dev/null 2>&1
 fi
else
 timeout 1 ssh -o StrictHostKeyChecking=no -o UserKnownHostsFile=/dev/null -o PasswordAuthentication=no ${USER}@${HOST} : 2>/dev/null
 if [ $? != 0 ]
 then
 exit 1
 else
 exit 0
 fi
fi
exit 0
