/*
    11 мая 2023 - добавлена аргумент - сообщение для теста MPV4
 */
#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>

#include <linux/mcst/mpv_io.h>

    char	name[128];
    int	verbose = 1;
    int	report_on_arrivalse = 0;	// сообщение для теста MPV4

    char	*inst, *chan;
    int	Ninst = 0;
    int Ncan =0;
    int	time = 1;
    int	silent = 0;

/*
 *  переменные для тестирования MPV4
 */
    struct  pollfd  pollfds[4];

int
do_inMPV4 (void) {
	int fd, poll_res, Ni, Nin = 0, IsExpectedIn = 0;

	for (Ni = 0; Ni < 4; Ni++) {
	    sprintf(name, "/dev/mpv/mpv_%s_in:%d", inst, Ni);
	    fd = open(name, O_RDWR);
	    if (fd < 0) {
		printf("Failed open(%s) - %m\n", name);
		return (-1);
	    }

	    pollfds[Ni].fd = fd;
	    pollfds[Ni].events = POLLIN;
	    pollfds[Ni].revents = 0;
	}
	poll_res = poll(pollfds, 4, time);

	if (poll_res > 0) {
	    char MIN[64], *MIN_ = MIN;
	    for (Ni = 0; Ni < 4; Ni++) {
		if (pollfds[Ni].revents) {
		    Nin++;
		    if (Ncan == Ni)
			IsExpectedIn = 1;
		    MIN_ += sprintf(MIN_, "%d ", Ni);
		}
	    }
	    if (poll_res != Nin)
		printf("!!! poll_res =%d, Nin =%d\n", poll_res, Nin);
	    if (MIN_ != MIN)
		printf("пришло %d IN :%s\n", poll_res, MIN);
	}
	else {
	    if (poll_res == 0) {
		printf("%s :poll - Time out -%m\n", __func__);
		return 1;
	    }
	    else
		printf("%s :error poll -%m\n", __func__);
	}
    if ((Nin == 1) && IsExpectedIn)
	return 0;
    return 2;
} // END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ do_inMPV4

void
do_in (int fd, int time) {
	struct	pollfd	pollfd;
	int	poll_res;

	pollfd.fd = fd;
	pollfd.events = POLLIN;
	pollfd.revents = 0;

	poll_res = poll(&pollfd, 1, time);

	if (poll_res > 0) {
	    if (report_on_arrivalse)
		printf("пришло IN %d\n", Ncan);
	    else if (verbose)
		printf("poll(&pollfd, 1, %d) ==%d - Success\n",
		    poll_res, time);
	    return;
	}
	else
	    if (poll_res == 0)
		printf("Time out poll(&pollfd, 1, %d) ==0\n", time);
	    else
		printf("poll(&pollfd, 1, %d) ==%d - %m\n",
		    time, poll_res);
} // END ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~ do_in

int
main (int argc, char *argv[]) {
	int	fd;

	inst = argv[1];
	chan = argv[2];
	time = atoi(argv[3]) * 1000;

	if (argc >= 4) {	// режим запуска для теста MPV4
	    verbose = 0;
	    report_on_arrivalse =1;
	    Ncan = atoi(chan);
	    silent = 1;
	    return do_inMPV4();
	}
	sprintf(name, "/dev/mpv/mpv_%s_in:%s", inst, chan);
	fd = open(name, O_RDWR);
	if (fd < 0) {
		printf("Failed open(%s) - %m\n", name);
		return (-1);
	}

	silent || printf("Waiting for signal on bus =%s\n", name);
	do_in(fd, time);

	close(fd);

	return (0);
}
