#pragma ident	"@(#)mpv_out.c 1.1	98/05/27 MCST"


#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>
#include <sys/ioctl.h>

#include <linux/mcst/mpv_io.h>

	int	fd;
	int	verbose = 0;
	int	silent = 0;
	char	*name = NULL;

static int
do_out(int width) {
    int	res = ioctl(fd, MPVIO_SEND_INTR, width);

    if (res || verbose)
	printf("%sioctl(%s, MPVIO_SEND_INTR, %d) - %m\n",
		res ? "!!! Failed !!! " : "", name, width);
    return res;
}

void
prn_help (char *nm) {
	printf("    Example program 'Signal output to MPV device bus'."
	    "\n\n%s options:"
		"\n\t-d <device name> - explicit assignment of MPV special device"
	    "\nor"
	    "\n    setting of <instance> and <N channel>"
	    "\n    for special device of MPV =/dev/mpv/mpv_<instance>_out:<N channel>"
		"\n\t-i <instance>	(default =0);"
		"\n\t-c <N channel> - bus output signal	(default =0);"

		"\n\n\t-w <wigth> - setting the width (in mcsec) output pulse"
			    "\n\t\t\t(default - not specified);"
		"\n\t-s - silent;"
		"\n\t-v - verbose;"
		"\n\t-h - help.\n", nm);
}

int
main(int argc, char *argv[])
{
	int	inst = 0;
	int	chan = 0;
	int	width = 0;
	int	help = 0;
	char	*device = NULL;
	char	buf[128];
	int	cur_opt = 0;

	while ( (cur_opt = getopt(argc, argv, "i:d:c:w:svh?")) != EOF ) {
	    switch (cur_opt) {
	    case 'i' :
		inst = atoi(optarg);
		break;
	    case 'c' :
		chan = atoi(optarg);
		break;
	    case 'w' :
		width = atoi(optarg);
		break;
	    case 'd' :
		name = optarg;
		 break;
	    case 's' :
		silent++;
		break;
	    case 'v' :
		verbose++;
		break;
	    case 'h' :
	    case '?' :
		help = 1;
		break;
             default :
		prn_help(argv[0]);
		return 1;
	    }
	}

	if (help) {
	    prn_help(argv[0]);
	    return 1;
	}
	if (!name) {
	    sprintf(buf, "/dev/mpv/mpv_%d_out:%d", inst, chan);
	    name = buf;
	}
	silent || printf("Output signal to bus =%s\n", name);
	fd = open(name, O_RDWR);
	if (fd < 0) {
		printf("Failed open(%s) - %m\n", name);
		return (-1);
	}

	do_out(width);

	(void) close(fd);

	return (0);
}
