#pragma ident	"@(#)mpv_st.c 1.1	98/05/27 MCST"

#include <stdio.h>
#include <fcntl.h>
#include <string.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <poll.h>
#include <sys/ioctl.h>

#include <linux/mcst/mpv_io.h>

char	name[128];
int	silent = 0;

static int
do_st(int fd, int state)
{
    if (!silent)
	printf("do_st :set signal level =%d, on bus =%s\n", state, name);

    if (ioctl(fd, MPVIO_SET_STATE, state) != 0) {
	printf("Failed ioctl(MPVIO_SET_STATE): %m\n");
	return 1;
    }
    if (!silent)
	printf("do_st :set signal level =%d, on bus =%s - SUCCESS\n", state, name);
    return 0;
}

int
main(int argc, char *argv[])
{
	char	*inst, *chan;
	int	state;
	int	fd;

	if (argc < 4) {
	    printf("\nExample program 'Set signal level(state) =0|1 on MPV device bus\n"
		"\tusage :mpv_st <inst> <chan> <state> [1 = mode silent]\n"
		"\nfor example :mpv_st 1 10 1\n"
		"\tTest on /dev/mpv/mpv_1_st:10\n"
		"\tset signal level =1, on bus =/dev/mpv/mpv_1_st:10\n\n");
	    return 0;
	}

	inst = argv[1];
	chan = argv[2];
	state = atoi(argv[3]);
	if (argc > 4)
	    silent = atoi(argv[4]);

	sprintf(name, "/dev/mpv/mpv_%s_st:%s", inst, chan);
	if (!silent)
	    printf("Test on %s\n", name);
	fd = open(name, O_RDWR);
	if (fd < 0) {
		printf("Failed open(%s): %m\n", name);
		return (-1);
	}

	do_st(fd, state);

	(void) close(fd);

	return (0);
}
