#!/bin/bash


MAINPATH="/sys/class/power_supply/"

COUNT=0
r=1

check_batt() {

BATTERY_PATH=$1

if [ -e $BATTERY_PATH ];
then
	PRESENT=$(cat $BATTERY_PATH/present)
	if [ $PRESENT -eq 0 ];
	then
		echo "--- Battery not found ---"
		printf "\n%-8s: %8s %s\n" "Result" " " "FAIL"
		exit 1
	fi
	SIGN=""
	TARGET=""
	STATE=$(cat $BATTERY_PATH/status)
	CAPACITY=$(cat $BATTERY_PATH/capacity)
	CURRENT=$(cat $BATTERY_PATH/current_now)
	REMAIN=$(($CURRENT%1000000))
	CURRENT=$(($CURRENT/1000000))
	hour=0
	min=0
	if [ "$STATE" = "Discharging" ];
	then
		SIGN="-"
		CURRENT=$(($CURRENT*(-1)))
		REMAIN=$(($REMAIN*(-1)))
		TIME_TO_EMPTY=$(cat $BATTERY_PATH/time_to_empty_avg)
		HOURS=$(($TIME_TO_EMPTY/3600))
		MINUTES=$(($TIME_TO_EMPTY%3600))
		MINUTES=$((MINUTES/60))
		hour="$HOURS"
		min="$MINUTES"
		TARGET="discharge"
	else
		if [ "$STATE" = "Charging" ];
		then
			TIME_TO_FULL=$(cat $BATTERY_PATH/time_to_full_avg)
			HOURS=$(($TIME_TO_FULL/3600))
			MINUTES=$(($TIME_TO_FULL%3600))
			MINUTES=$((MINUTES/60))
			hour="$HOURS"
			min="$MINUTES"
			TARGET="full charge"
		fi
	fi

	printf "%-8s: %8s %s\n" "Battery" " " "$(cat $BATTERY_PATH/manufacturer)"
	printf "%-8s: %8s %s\n" "Model" " " "$(cat $BATTERY_PATH/model_name)"
	printf "%-8s: %8s %s\n" "Status" " " "$STATE"
	printf "%-8s: %8s %s%s\n" "Capacity" " " "$CAPACITY" '%'
	printf "%-8s: %8s %s%d.%06d A\n" "Current" " " "$SIGN" "$CURRENT" "$REMAIN"
	if [ "$STATE" = "Discharging" ] || [ "$STATE" = "Charging" ]; then
		printf "Time to %s: %02d:%02d:00\n" "$TARGET" "$HOURS" "$MINUTES"
	fi
	
	echo
	(( COUNT = $COUNT + 1 ))
fi
}

if [[ -z $1 ]]; then
	for i in `ls ${MAINPATH}`; do
		echo "*** $i ***"
		check_batt ${MAINPATH}/$i
	done
else
	echo "++ $1 +++"
	check_batt $1
fi

if [[ $COUNT -ne 0 ]]; then
	r=0
	printf "%-8s: %8s %s\n" "Result" " " "SUCCESS"
fi

exit $r
