#!/bin/bash

FL=`command -v flashrom`
# board specific
FL_DEVICE="/dev/spidev0.0"

if [[ -z $FL ]]; then
	echo "flashrom not found !"
	echo "Test SPI are skipped."
	exit 2
fi

modprobe spidev

DIR=$(dirname `realpath $0`)
CDIR=`pwd`
cd $DIR

PARAM_FILE=$1
if [[ -z $1 ]]; then
	$FL -p linux_spi:dev=$FL_DEVICE,spispeed=12500 2>/dev/null | grep "Found"
	if [[ ! "x$?" == "x0" ]]; then
		echo -e "\t\tFAIL"
		exit 1
	else
		echo -e "\t\tSUCCESS"
		exit 0
	fi
fi

#init array's
declare -a devices
declare -a names

while read line ; do
    devices+=($(echo $line | awk -F= '{print $1}'))
    names+=($(echo $line | awk -F= '{print $2}'))
done < <(cat ${PARAM_FILE} | grep -v ^# | sed '/^[[:space:]]*$/d')

C=0
cnt=0
for i in ${devices[@]}; do
	echo "$i --> ${names[$cnt]}"
	$FL -p linux_spi:dev=${i},spispeed=12500 | grep ${names[$cnt]} | grep linux 2>/dev/null 1>&2
	if [[ ! "x$?" == "x0" ]]; then
		echo -e "\t\tFAIL"
		(( C = $C + 1 ))
	else
		echo -e "\t\tSUCCESS"
	fi
	(( cnt = $cnt + 1 ))
done

cd $CDIR

if [[ $C -eq 0 ]]; then
    exit 0
else
    exit 1
fi

